import java.math.BigInteger;
import java.util.ArrayList;


/**
 * 剣クラスです。
 * @author theki
 *
 */
public class Action {
	
	// type定義用　剣リストの並び順と同じ
	public static final int
		ZANGEKI = 0, KOUSOKU = 1, JUGEKI = 2, SHOUGEKI = 3, KODOKU = 4,
		ZETTAI = 5, MAHOU = 6, DEATH = 7, KANETU = 8, KAGO = 9,
		KASOKU = 10, TATE = 11 , KAGAMI = 12, INOTI = 13, KAIFUKU = 14,
		NULL = 15, SAKIHI = 16, MESSOU = 17, GEKIDO = 18, ONSOKU = 19,
		LIGHT = 20, KAKUJITU = 21, TWO = 22, THREE = 23, FOUR = 24,
		FIVE = 25, SIX = 26, SEVEN = 27, BUTOU = 28, ZENTAI = 29,
		MOUDOKU = 30, DATAI = 31, REIKYAKU = 32, HAKURAKU = 33, GENSOKU = 34,
		HAKAI = 35, KENGEKI = 36, KAKURAN = 37, KYUKETU = 38, GOUTOU = 39,
		ANKOKU = 40, TAMASII = 41, OSHIWAKE = 42, YUIN = 43, SENKOU = 44, 
		KOUZOKU = 45, KAIYU = 46, GISHIKI = 47, GARYU = 48, SYAKUNETU = 49,
		GENTEI = 50, DOURAI = 51, TITAI = 52, KITAI = 53, SHINDOU = 54,
		DOKUYAKU = 55, KAKUSAN = 56, SAIRAI = 57, KYOUMEI = 58, KYOKOU = 59,
		FUKUSEI = 60, ZOUSHOKU = 61, SEISOU = 62, BOUBLE = 63, FENCE = 64,
		GATE = 65, WALL = 66, ICEA = 67, MISTIA = 68, UNDINE = 69,
		EISHOU = 70, KITOU = 71, MOKUTOU = 72, GAGEKI = 73, MAFU = 74 ;
	// genre定義用（実行種別(補助、制御、追加、攻撃、構築、環境
	public static final int SPT = 0, CTR = 1, ADD = 2, ATK = 3, BLD = 4, ENV = 5 ;
	
	// 剣の名前
	public static final String[] NAME = {
		"斬撃剣", "高速剣", "重撃剣", "衝撃剣", "蟲毒剣",
		"絶対剣", "魔法剣", "デス剣", "加熱剣", "加護剣",
		"加速剣", "盾の剣", "鏡の剣", "命の剣", "回復剣",
		"ヌル剣", "咲火剣", "滅奏剣", "激怒剣", "音速剣",
		"光速剣", "確実剣", "二撃剣", "三撃剣", "四撃剣",
		"五撃剣", "六撃剣", "七撃剣", "舞踏剣", "全体剣",
		"猛毒剣", "堕胎剣", "冷却剣", "剥落剣", "減速剣",
		"破壊剣", "剣戟剣", "撹乱剣", "吸血剣", "強盗剣",
		"闇黒剣", "魂の剣", "押分剣", "誘引剣", "先行剣",
		"後続剣", "快癒剣", "儀式剣", "臥竜剣", "灼熱剣",
		"限定剣", "導来剣", "遅滞剣", "危殆剣", "振動剣",
		"毒薬剣", "拡散剣", "再来剣", "共鳴剣", "虚構剣",
		"複製剣", "増殖剣", "星霜剣", "造泡剣", "造柵剣",
		"造門剣", "造壁剣", "造氷剣", "造霧剣", "造涙剣",
		"詠唱剣", "祈祷剣", "黙祷剣", "牙撃剣", "魔封剣"
	} ;

	// 剣の略称
	public static String[] ABBR = {
		"斬", "高", "重", "衝", "毒", "絶", "魔", "死", "熱", "護",
		"速", "盾", "鏡", "命", "回", "ヌ", "咲", "滅", "怒", "音",
		"光", "確", "二", "三", "四", "五", "六", "七", "舞", "全",
		"猛", "堕", "冷", "剥", "減", "壊", "戟", "撹", "吸", "盗",
		"闇", "魂", "押", "誘", "先", "後", "癒", "儀", "臥", "灼",
		"限", "導", "遅", "危", "振", "薬", "散", "再", "鳴", "虚",
		"複", "増", "星", "泡", "柵", "門", "壁", "氷", "霧", "涙",
		"詠", "祈", "黙", "牙", "封"
	} ;

	// 剣の種類、実行種別
	private int type, genre ;
	// 起動時間、毒与え、スタン与え、連撃回数、MP
	private int boot, poison, stan, hit, mp ;
	// リミテッド、全体化、対症、危殆
	private boolean limited, whole, symptom, pinch ;
	// 剣の実行時に対象とする剣師
	private ArrayList<Player> targetPlayers ;
	// 剣の実行時に対象とする剣
	private Action targetAction ;
	// 防護を無視するかどうか
	private boolean ignoreGuard ;
	// 防衛を無視するかどうか
	private boolean ignoreMirror ;
	// 使用中かどうか
	private boolean used ;
	// 遅延起動が設定されている,もしくは変化しているかどうか
	private boolean bootChangeFlag ;
	// スタン/毒与え/リミテッド/全体化が新たに付与されているかどうか
	private boolean stanChangeFlag, poisonChangeFlag, limitedChangeFlag, wholeChangeFlag, pinchChangeFlag ;
	
	public int getType() {
		return type;
	}
	public void setType(int type) {
		this.type = type;
	}
	public int getBoot() {
		return boot;
	}
	public void setBoot(int boot) {
		this.boot = boot;
	}
	public int getPoison() {
		return poison;
	}
	public void setPoison(int poison) {
		this.poison = poison;
	}
	public int getStan() {
		return stan;
	}
	public void setStan(int stan) {
		this.stan = stan;
	}
	public boolean isPinch() {
		return pinch;
	}
	public void setPinch(boolean pinch) {
		this.pinch = pinch;
	}
	public boolean isLimited() {
		return limited;
	}
	public void setLimited(boolean limited) {
		this.limited = limited;
	}
	public boolean isWhole() {
		return whole;
	}
	public void setWhole(boolean whole) {
		this.whole = whole;
	}
	public boolean isSymptom() {
		return symptom;
	}
	public void setSymptom(boolean symptom) {
		this.symptom = symptom;
	}
	public int getGenre() {
		return genre;
	}
	public void setGenre(int genre) {
		this.genre = genre;
	}
	public int getHit() {
		return hit;
	}
	public void setHit(int hit) {
		this.hit = hit;
	}
	public int getMp() {
		return mp;
	}
	public void setMp(int mp) {
		this.mp = mp;
	}
	public boolean isIgnoreGuard() {
		return ignoreGuard;
	}
	public void setIgnoreGuard(boolean ignoreGuard) {
		this.ignoreGuard = ignoreGuard;
	}

	public boolean isIgnoreMirror() {
		return ignoreMirror;
	}
	public void setIgnoreMirror(boolean ignoreMirror) {
		this.ignoreMirror = ignoreMirror;
	}

	public boolean isBootChangeFlag() {
		return bootChangeFlag;
	}
	public void setBootChangeFlag(boolean bootChangeFlag) {
		this.bootChangeFlag = bootChangeFlag;
	}

	public boolean isStanChangeFlag() {
		return stanChangeFlag;
	}

	public void setStanChangeFlag(boolean stanChangeFlag) {
		this.stanChangeFlag = stanChangeFlag;
	}

	public boolean isPoisonChangeFlag() {
		return poisonChangeFlag;
	}

	public void setPoisonChangeFlag(boolean poisonChangeFlag) {
		this.poisonChangeFlag = poisonChangeFlag;
	}

	public boolean isLimitedChangeFlag() {
		return limitedChangeFlag;
	}

	public void setLimitedChangeFlag(boolean limitedChangeFlag) {
		this.limitedChangeFlag = limitedChangeFlag;
	}

	public boolean isWholeChangeFlag() {
		return wholeChangeFlag;
	}

	public void setWholeChangeFlag(boolean wholeChangeFlag) {
		this.wholeChangeFlag = wholeChangeFlag;
	}

	public boolean isPinchChangeFlag() {
		return pinchChangeFlag;
	}

	public void setPinchChangeFlag(boolean pinchChangeFlag) {
		this.pinchChangeFlag = pinchChangeFlag;
	}

	public boolean isUsed() {
		return used;
	}
	public void setUsed(boolean used) {
		this.used = used;
	}

	public ArrayList<Player> getTargetPlayers() {
		return targetPlayers;
	}

	public void setTargetPlayers(ArrayList<Player> targetPlayers) {
		this.targetPlayers = targetPlayers;
	}

	public Action getTargetAction() {
		return targetAction;
	}

	public void setTargetAction(Action target) {
		this.targetAction = target;
	}

	/**
	 * コンストラクタ
	 * 文字列actionDataより、剣のインスタンスを生成します。
	 * 
	 * actionDataは、以下の要素から成り立ちます。
	 * 1.剣の略称 ： 剣の名称に含まれる、指定された1文字
	 * 2.遅延起動/ピリオド(遅延剣の場合) : 0~20までの数字
	 * 3.スタン与えn : Sn
	 * 4.毒与えn : Pn
	 * 5.全体化 : W
	 * 6.リミテッド : L
	 * 
	 * 必須の項目は1.のみであり、その他の項目は剣のエンチャントに応じて自由に設定が可能です。
	 * また、1.と2.以外の記述順序は自由です。遅延起動とピリオドは同時に設定できません。
	 * 早期起動については、早期起動を考慮した遅延起動数を設定してください。
	 * 
	 * @param actionData
	 * @throws Exception 
	 */
	public Action( String actionData ) throws Exception{
		// 初期化
		limited = whole = false ;
		type = -1 ;
		pinch = false ;
		poison = stan = 0 ;
		boot = hit = 1 ;
		used = symptom = false ;
		targetAction = null ;
		mp = Integer.MIN_VALUE ;
		
		// 剣の決定
		prisetAction( actionData.charAt(0) );
		
		// 遅延起動設定（設定出来る剣かどうかに関わらず、数字が記述されていれば設定
		int i = 0 ;
		int num = Util.getNextNum(actionData, i);
		// 数字が記述されているなら
		if( num != Integer.MAX_VALUE ){
			boot = num ;
			bootChangeFlag = true ;
			i ++ ;
			if( num >= 10 )
				i += Math.log10((int)num);
		}
		i++ ;
		
		// エンチャント設定（記述の順序は自由
		while( i < actionData.length() ){
			char c = actionData.charAt(i);
			// スタン与え
			if( c == 'S' ){
				num = Util.getNextNum(actionData, i);
				if( num != Integer.MAX_VALUE ){
					stan = num ;
					i ++ ;
					if( num >= 10 )
						i += Math.log10((int)num);
				}
				else
					stan = 1 ;
				stanChangeFlag = true ;
				i ++ ;
				continue ;
			}
			// 毒与え
			if( c == 'P' ){
				num = Util.getNextNum(actionData, i);
				if( num != Integer.MAX_VALUE ){
					poison = num ;
					i ++ ;
					if( num >= 10 )
						i += Math.log10((int)num);
				}
				else
					poison = 1 ;
				poisonChangeFlag = true ;
				i ++ ;
				continue ;

			}
			// 全体化
			if( c == 'W' ){
				i ++ ;
				whole = true ;
				wholeChangeFlag = true ;
				continue ;
			}
			// リミテッド
			if( c == 'L' ){
				i ++ ;
				limited = true ;
				limitedChangeFlag = true ;
				continue ;
			}
			// 危殆
			if( c == 'D' ){
				i ++ ;
				pinch = true ;
				pinchChangeFlag = true ;
				continue ;
			}
		}
	}

	/**
	 * 剣の略称である文字cから、剣固有のデータを取得し、設定を保存します。
	 * 設定されるパラメータは、type,genre,mp,hit,ignoreGuard,ignoreMirror,
	 * poison,stan,while,limited,boot,attackerです。
	 * @param c　剣の略称である文字列
	 * @throws Exception 
	 */
	private void prisetAction( char c ) throws Exception{
		for(int i=0;i<ABBR.length;i++){
			if( ABBR[i].charAt(0) == c ){
				type = i ;
				break ;
			}
		}
		if( type == -1 )
			throw new Exception("剣師定義ファイルに、存在しない剣\""+c+"\"が含まれています。");

		// 剣の実行種別
	         if( type <= DEATH ) genre = ATK ;
	    else if( type <= KAIFUKU ) genre = SPT ;
	    else if( type <= ANKOKU ) genre = ATK ;
		else if( type <= SYAKUNETU ) genre = SPT ;
		else if( type <= KYOUMEI ) genre = CTR ;
		else if( type <= ZOUSHOKU ) genre = ADD ;
		else if( type <= SEISOU ) genre = ENV ;
		else if( type <= UNDINE ) genre = BLD ;
		else if( type <= MOKUTOU ) genre = SPT ;
		else if( type <= MAFU ) genre = ATK ;
		else genre = -1 ;
		
	    // 遅延起動
		if( type == KOUSOKU || type == NULL || type == ONSOKU
		 || type == LIGHT || type == OSHIWAKE || type == YUIN || type == SENKOU
		 || type == KOUZOKU || type == GISHIKI || type == GARYU || type == GENTEI
		 || type == DOURAI || type == TITAI || type == KITAI || type == EISHOU || type == KITOU
		 || genre == BLD )
			boot = 0 ;
		else if( type == SHOUGEKI || type == MAHOU || type == KAGAMI
			  || type == ZENTAI || type == MOUDOKU || type == REIKYAKU || type == HAKURAKU
			  || type == GENSOKU || type == KENGEKI || type == GOUTOU || type == ANKOKU
			  || type == GAGEKI )
			boot = 2 ;
		else if( type == ZETTAI || type == BUTOU || type == TAMASII
			  || type == SYAKUNETU || type == SAIRAI )
			boot = 3 ;
		else if( type == KYOUMEI || type == JUGEKI )
			boot = 4 ;
		else if( type == FIVE )
			boot = 5 ;
		else if( type == DEATH )
			boot = 6 ;
		else if( type >= TWO && type <= SEVEN )
			boot = type - TWO + 2 ;
		
		
		// リミテッド
		if( type == KOUSOKU || type == KODOKU || type == MAHOU || type == DEATH 
		 || type == KAGAMI || type == INOTI || type == KAIFUKU || type == MESSOU
		 || type == GEKIDO || type == ONSOKU || type == LIGHT || type == MOUDOKU
		 || type == DATAI || type == HAKAI || type == KAKURAN || type == KYUKETU
		 || type == GOUTOU || type == TAMASII || type == OSHIWAKE || type == YUIN
		 || type == SENKOU || type == KOUZOKU || type == KAIYU || type == GISHIKI
		 || type == GARYU || type == SYAKUNETU || type == FUKUSEI || type == KITOU
		 || type == MAFU || type == MOKUTOU || genre == CTR || genre == BLD )
			limited = true ;
		
		// 危殆
		if( type == KAIFUKU || type == MESSOU || type == GEKIDO )
			pinch = true ;
		
		// MP
		if( type == ZOUSHOKU )
			mp = 1 ;
		else if( type == BOUBLE )
			mp = 2 ;
		else if( type == FENCE || type == ICEA )
			mp = 3 ;
		else if( type == GATE || type == MISTIA )
			mp = 4 ;
		else if( type == WALL || type == UNDINE )
			mp = 5 ;
		
		// 連撃など
		else if( type == ONSOKU ) hit = 10 ;
		else if( type == LIGHT ) hit = 100 ;
		else if( type >= TWO && type <= SEVEN )
			hit = type - TWO + 2 ;
		else if( type == KODOKU ) poison = 1 ;
		else if( type == SHOUGEKI ) stan = 1 ;
		else if( type == ANKOKU ){
			ignoreGuard = true ;
			ignoreMirror = true ;
		}
		else if( type == ZENTAI )
			whole = true ;
		else if( type == KAIYU )
			symptom = true ;
	}
	
	/**
	 * 剣の状態を文字列表現によって返します。
	 * この関数をactionDataとして、Actionのインスタンスを生成することで、
	 * 同等の効果を持った剣のインスタンスを生成することが可能です。
	 * @return
	 */
	public String getStates(){
		String str = ABBR[type] ;
		if(bootChangeFlag)str+=boot;
		if(stan>0 && stanChangeFlag)str+="S"+stan;
		if(poison>0 && poisonChangeFlag)str+="P"+poison;
		if(whole && wholeChangeFlag)str+="W";
		if(limited && limitedChangeFlag)str+="L";
		if(pinch && pinchChangeFlag)str+="D";
		
		return str ;
	}

	/**
	 * 攻撃系の剣の実行処理です。
	 * ダメージを伴わない攻撃剣についての処理は、additionEffectメソッドによって行われます。
	 * @param Player a　攻撃側剣師
	 * @param Player b　防御側剣師
	 * @return　damage　ダメージ量
	 */
	public BigInteger execAttack( Player a, Player b, int turn ){
		BigInteger damage = BigInteger.ZERO ;
		// ダメージ量の決定
		if( type == JUGEKI || type == GAGEKI )
			damage = a.getAtk().shiftLeft(1).subtract(b.getDef()) ;
		else if( type == ONSOKU )
			damage = a.getAtk().divide(BigInteger.valueOf(5)).subtract(b.getDef()) ;
		else if( type == LIGHT )
			damage = a.getAtk().divide(BigInteger.TEN).subtract(b.getDef()) ;
		else if( type == MAHOU )
			damage = b.getHp().subtract(b.getHp().shiftRight(1)) ;
		else if( type == ZETTAI )
			damage = a.getAtk() ;
		else if( type == KAKUJITU )
			damage = a.getAtk().shiftRight(1) ;
		else if( type == DEATH )
			damage = b.getHp() ;
		else if( type == SAKIHI )
			damage = BigInteger.ONE ;
		else if( type == MESSOU )
			damage = BigInteger.valueOf((long) Math.pow(2, turn)) ;
		else if( type == GEKIDO )
			damage = a.getMaxHp().subtract(a.getHp()) ;
		else if( type == NULL )
			damage = BigInteger.ZERO ;
		else
			damage = a.getAtk().subtract(b.getDef()) ;

		// 防護系
		if( !ignoreGuard && b.getGuard() > 0 ){
			Util.outputString("      --"+b.getComment()+",　ガード発動。\n" ,SettingMatch.ResultFileName) ;
			damage = damage.subtract(damage.shiftRight(1)) ;
			b.addGuard(-1);
		}

		// 魔封剣の特殊処理
		if( type == MAFU && damage.compareTo(BigInteger.ZERO) > 0 ){
			b.setMp( b.getMp()-damage.intValue() );
			b.printStatus(false, true);
		}

		return damage ;
	}
	
	/**
	 * 補助系の剣の実行処理です。
	 * @param a　実行者
	 * @param b　対象者
	 * @param turn　現在ターン数
	 */
	public void execSupport( Player a, Player b, int turn ){
		// 基本効果の実行
		if(type==KANETU)
			b.addAtk(BigInteger.ONE);
		else if(type==KAGO)
			b.addDef(BigInteger.ONE);
		else if(type==KASOKU)
			b.addSpd(BigInteger.ONE);
		else if(type==TATE)
			b.addGuard(1);
		else if(type==KAGAMI)
			b.addReflection(1);
		else if(type==INOTI)
			b.addLife(1);
		else if(type==KAIFUKU)
			b.healLife( turn ) ;
		else if(type==TAMASII)
			b.addSoul(1);
		else if(type==OSHIWAKE)
			b.addPush(1);
		else if(type==YUIN)
			b.setAppeal(true);
		else if(type==SENKOU)
			b.addQuick(1);
		else if(type==KOUZOKU)
			b.addSlow(1);
		else if(type==KAIYU){
			b.setDeadly(0);
			b.setMiscarriage(0);
			b.setSleep(0);
			b.setStan(0);
			b.setPoison(0);
		}
		else if(type==GISHIKI)
			b.setSubAp(b.getSubAp().add(BigInteger.valueOf(3)));
		else if(type==GARYU){
			b.setHp( b.getHp().add(BigInteger.TEN) );
			b.setMaxHp( b.getMaxHp().add(BigInteger.TEN) );
			b.addSleep(1);
		}
		else if(type==SYAKUNETU)
			b.addAtk(b.getAtk());
		else if(type==EISHOU)
			b.setMp(b.getMp()+1);
		else if(type==KITOU)
			b.setMp(b.getMp()+2);
		else if(type==MOKUTOU)
			b.setMp(b.getMp()+3);

		b.printStatus(false, true);
	}
	
	/**
	 * 制御系の剣の実行処理です。
	 * @param p　対象者
	 * @throws Exception 
	 */
	public void execControl( Player p ) throws Exception{
		// 再来剣
		if(type==SAIRAI){
			ArrayList<Action> actions = p.getActions() ;
			for(int i=0;i<actions.size();i++)
				actions.get(i).setUsed(false);
			p.setActions(actions);
		}
		// 制御対象とする剣が事前に決定されていなかった場合、エラー
		else if( targetAction == null ){
			Util.outputString("      --"+p.getComment()+"には制御できる剣がない。 \n" ,SettingMatch.ResultFileName );
			return ;
		}
		
		// 共鳴剣
		if(type==KYOUMEI){
			ArrayList<Action> actions = new ArrayList<Action>() ;
			for(int i=0;i<p.getActions().size();i++){
				Action add = new Action( targetAction.getStates() ) ;
				if( p.getActions().get(i).isUsed())
					add.setUsed(true);
				actions.add(add);
			}
			p.setActions(actions);
		}
		// 限定剣
		else if( type == GENTEI ){
			targetAction.setLimited(true);
			targetAction.setLimitedChangeFlag(true);
		}
		// 導来剣
		else if( type == DOURAI ){
			if( targetAction.getBoot() != 0 ){
				targetAction.setBoot( targetAction.getBoot()-1 );
				targetAction.setBootChangeFlag(true);
			}
		}
		// 遅滞剣
		else if( type == TITAI ){
			targetAction.setBoot( targetAction.getBoot()+1 );
			targetAction.setBootChangeFlag(true);
		}
		// 危殆剣
		else if( type == KITAI && !targetAction.isPinch() ){
			targetAction.setPinch(true);
			targetAction.setPinchChangeFlag(true);
		}
		// 振動剣
		else if( type == SHINDOU && targetAction.getGenre() == ATK ){
			targetAction.setStan( targetAction.getStan()+1 );
			targetAction.setStanChangeFlag(true);
		}
		// 毒薬剣
		else if( type == DOKUYAKU && targetAction.getGenre() == ATK ){
			targetAction.setPoison( targetAction.getPoison()+1 );
			targetAction.setPoisonChangeFlag(true);
		}
		// 拡散剣
		else if( type == KAKUSAN && ( targetAction.getGenre() == ATK || targetAction.getGenre() == SPT ) ){
			targetAction.setWhole( true ) ;
			targetAction.setWholeChangeFlag(true);
		}
		p.printStatus(false, true);
	}


	/**
	 * 構築・環境系の剣の実行処理です。
	 * @param p　対象者
	 * @param party　対象者のパーティ
	 * @param eParty 対象者の敵軍のパーティ
	 * @param turn　現在のターン数
	 * @throws Exception 
	 */
	public int execBuildAndEnv( Player p, Party party, Party eParty, int turn ) throws Exception{
		// 星霜剣
		if( genre == ENV ){
			Util.outputString("--turn:"+(turn+1)+"\n" ,SettingMatch.ResultFileName);
			return turn + 1;
		}

		// 各種ビルド失敗判定
		if( p.getMiscarriage() > 0 ){
			Util.outputString("      --流産によりビルド失敗。\n" ,SettingMatch.ResultFileName);
			p.addMiscarriage(-1);
			return turn ;
		}

		// ビルド処理
		Player child = null ;
		child = new Player(0,Player.publicStrage[ type-BOUBLE ]);
		if( SettingMatch.buildCount[type-BOUBLE] != 0 )
			child.setComment( child.getComment()+"_"+SettingMatch.buildCount[type-BOUBLE] );
		SettingMatch.buildCount[type-BOUBLE] ++ ;
		child.setMasterStr(p.getMasterStr());
		party.getMember().add(0,child);
		return turn ;
	}

	/**
	 * 追加系の剣の実行処理です。追加する剣を返します。
	 * @param p　対象者
	 * @param eParty　対戦相手のパーティ
	 * @return　追加するActionのインスタンス
	 * @throws Exception 
	 */
	public Action execAdd(Player p, Party eParty) throws Exception {
		// 虚構剣
		if(type==KYOKOU)
			return new Action("ヌ");
		// 増殖剣
		else if(type==ZOUSHOKU){
			if( targetAction != null ){
				Action add = new Action( targetAction.getStates() ) ;
				add.setUsed(false);
				return add ;
			}
			else
				Util.outputString("      --増殖する剣がなかった。\n" ,SettingMatch.ResultFileName);
		}
		// 複製剣
		else if(type==FUKUSEI){
			if( eParty.getMember().get(0).getActions().size() > 0 ){
				Action action = new Action(eParty.getMember().get(0).getActions().get(0).getStates());
				action.setUsed(false);
				return action ;
			}
		}
			
		return null ;
	}

	
	/**
	 * 「さらに」の効果です。
	 * @param ap　実行者
	 * @param bp　対象者
	 * @param damage　その剣によるダメージ量
	 * @param turn　ターン数
	 */
	public void additionEffect( Player a, Player b, Action ba, BigInteger damage, int turn ){
		
		// ダメージ追加効果
		if( damage.compareTo(BigInteger.ZERO) > 0 ){
			if(stan>0){
				Util.outputString("      --"+b.getComment()+", スタン*"+stan+"付与。\n" ,SettingMatch.ResultFileName);
				b.addStan(stan);
			}
			if(poison>0){
				Util.outputString("      --"+b.getComment()+", 毒*"+poison+"付与。\n" ,SettingMatch.ResultFileName);
				b.addPoison(poison);
			}
			if( type == MOUDOKU ){
				Util.outputString("      --"+b.getComment()+", 猛毒付与。\n" ,SettingMatch.ResultFileName);
				b.addDeadly(1);
			}
			else if( type == DATAI ){
				Util.outputString("      --"+b.getComment()+", 流産付与。\n" ,SettingMatch.ResultFileName);
				b.addMiscarriage(1);
			}
			else if( ( type == HAKAI ) && b.getActions().size() > 0 ){
				Action action = b.getActions().get(0);
				b.getActions().remove(0);

				Util.outputString("      --"+b.getComment()+"の"+Action.NAME[action.getType()]+"を破壊。\n" ,SettingMatch.ResultFileName);
			}
			else if( type == KENGEKI&& b.getActions().size() > 0 ){
				Action action = null ;
				for(int i=0;i<b.getActions().size();i++){
					action = b.getActions().get(i);
					if( !action.isUsed() )
						break ;
				}
				if( action != null ){
					action.setUsed(true);
					Util.outputString("      --"+b.getComment()+"の"+Action.NAME[action.getType()]+"を使用済みに。\n" ,SettingMatch.ResultFileName);
				}
			}
			else if( type == KAKURAN && b.getActions().size() > 0 ){
				ArrayList<Action> newActions = new ArrayList<Action>();
				for(int i=0;i<b.getActions().size();i++){
					newActions.add( b.getActions().get( b.getActions().size()-i-1 )) ;
				}
				b.setActions( newActions ) ;
				Util.outputString("      --"+b.getComment()+"の剣を撹乱。\n" ,SettingMatch.ResultFileName);
			}
			else if( type == REIKYAKU ){
				b.setAtk( BigInteger.valueOf(b.getBaseAtk()) );
				Util.outputString("      --"+b.getComment()+",攻撃力:"+b.getAtk()+"。　\n" ,SettingMatch.ResultFileName);
			}
			else if( type == HAKURAKU ){
				b.setDef( BigInteger.valueOf(b.getBaseDef()) );
				Util.outputString("      --"+b.getComment()+",防御力:"+b.getDef()+"。　\n" ,SettingMatch.ResultFileName);
			}
			else if( type == GENSOKU ){
				b.setSpd( BigInteger.valueOf(b.getBaseSpd()) );
				Util.outputString("      --"+b.getComment()+",素早さ:"+b.getSpd()+"。　\n" ,SettingMatch.ResultFileName);
			}
		}
	}

	/**
	 * 「そして」の効果です。
	 * 強盗剣を使用した時のみ、奪う剣を返します。強盗剣以外を使用したとき、nullが返ります。
	 * @param ap　実行者
	 * @param bp　対象者
	 * @param damage その剣が与えるダメージ量
	 * @param turn 現在のターン数
	 */
	public Action optionEffect(Player ap, Player bp, BigInteger damage,int turn) {
		if( damage.compareTo(BigInteger.ZERO) > 0 && type == KYUKETU ){
			if( ap.getHp().compareTo(ap.getMaxHp()) < 0 ){
				ap.setHp( ap.getHp().add(damage) );
				if( ap.getHp().compareTo(ap.getMaxHp()) > 0 )
					ap.setHp( ap.getMaxHp() );
				Util.outputString( "      --HP吸収発動！"+ap.getComment()+"、HP:"+ap.getHp()+"\n" ,SettingMatch.ResultFileName);
			}
		}
		else if( damage.compareTo(BigInteger.ZERO) > 0 && type == GOUTOU && bp.getActions().size() > 0 ){
			return bp.getActions().get(0);
		}
		return null ;

	}

	/**
	 * ：「／」で区切られた効果です。
	 * @param p 実行者
	 * @param action　その剣の実行時のtype（同時行動により変化している可能性があるため
	 * @param turn　現在のターン数
	 */
	public void secondEffect(Player p, Action action, int turn) {
		int oldType = action.getType() ;
		if( oldType == BUTOU )
			used = false ;
	}

}
